PRAGMA recursive_triggers=1;     --- test

CREATE TABLE user (
	id INTEGER PRIMARY KEY AUTOINCREMENT,
	username TEXT NOT NULL UNIQUE,
	email TEXT NOT NULL,
	points INTEGER NOT NULL DEFAULT 0,
	level INTEGER NOT NULL DEFAULT 1,
	password TEXT NOT NULL,
    created_at DATETIME NOT NULL DEFAULT CURRENT_TIMESTAMP,
    updated_at DATETIME NOT NULL DEFAULT CURRENT_TIMESTAMP
);

CREATE TABLE role (
	id INTEGER PRIMARY KEY AUTOINCREMENT,
	role_name TEXT NOT NULL
);

CREATE TABLE user_role (
	u_id INTEGER,
	r_id INTEGER,
    PRIMARY KEY (u_id, r_id),
    FOREIGN KEY (u_id) 
    REFERENCES user (id) 
    ON DELETE NO ACTION 
    ON UPDATE NO ACTION,
    FOREIGN KEY (r_id) 
    REFERENCES role (id) 
    ON DELETE NO ACTION 
    ON UPDATE NO ACTION
    
);


CREATE TABLE project (
	id INTEGER PRIMARY KEY AUTOINCREMENT,
	name TEXT NOT NULL,
	type TEXT NOT NULL,
	icon TEXT NOT NULL,
    description TEXT,
    labels TEXT NOT NULL,
    redundancy BOOLEAN NOT NULL,
    created_at DATETIME NOT NULL DEFAULT CURRENT_TIMESTAMP,
    updated_at DATETIME NOT NULL DEFAULT CURRENT_TIMESTAMP,
    CHECK (redundancy IN (0,1) AND type IN ("text", "image", "audio"))
);

CREATE TABLE task (
	id INTEGER PRIMARY KEY AUTOINCREMENT,
	text TEXT NOT NULL,
	location TEXT NOT NULL,
	state TEXT NOT NULL,
    project_id INTEGER NOT NULL,
    assigned_to INTEGER,
    created_at DATETIME NOT NULL DEFAULT CURRENT_TIMESTAMP,
    updated_at DATETIME NOT NULL DEFAULT CURRENT_TIMESTAMP,
    FOREIGN KEY (project_id) 
    REFERENCES project (id) 
    ON DELETE NO ACTION 
    ON UPDATE NO ACTION,
    FOREIGN KEY (assigned_to) 
    REFERENCES user (id) 
    ON DELETE NO ACTION 
    ON UPDATE NO ACTION
);

CREATE TABLE result (
	id INTEGER PRIMARY KEY AUTOINCREMENT,
	label TEXT NOT NULL,
	state TEXT NOT NULL,
    task_id INTEGER NOT NULL,
    user_id INTEGER NOT NULL,
    created_at DATETIME NOT NULL DEFAULT CURRENT_TIMESTAMP,
    updated_at DATETIME NOT NULL DEFAULT CURRENT_TIMESTAMP,
    FOREIGN KEY (task_id) 
    REFERENCES task (id) 
    ON DELETE NO ACTION 
    ON UPDATE NO ACTION,
    FOREIGN KEY (user_id) 
    REFERENCES user (id) 
    ON DELETE NO ACTION 
    ON UPDATE NO ACTION
);

CREATE TABLE transaction (
	id INTEGER PRIMARY KEY AUTOINCREMENT,
	points INTEGER NOT NULL,
	result_id INTEGER NOT NULL,
    created_at DATETIME NOT NULL DEFAULT CURRENT_TIMESTAMP,
    updated_at DATETIME NOT NULL DEFAULT CURRENT_TIMESTAMP,
    FOREIGN KEY (result_id) 
    REFERENCES result (id) 
    ON DELETE NO ACTION 
    ON UPDATE NO ACTION
);

-- CREATE TABLE upload (
-- 	id INTEGER PRIMARY KEY AUTOINCREMENT,
-- 	name TEXT NOT NULL,
-- 	location TEXT NOT NULL,
--     created_at DATETIME NOT NULL DEFAULT CURRENT_TIMESTAMP,
--     updated_at DATETIME NOT NULL DEFAULT CURRENT_TIMESTAMP
-- );

-- CREATE TABLE exampleTable1 (
-- 	id INTEGER PRIMARY KEY AUTOINCREMENT,
-- 	field1 TEXT NOT NULL,
-- 	field2 TEXT NOT NULL,
-- 	field3 TEXT NOT NULL UNIQUE,
-- );

-- CREATE TABLE exampleTable2 (
-- 	id INTEGER PRIMARY KEY AUTOINCREMENT,
-- 	field4 TEXT NOT NULL
-- );


-- CREATE TABLE relationTable12 (
-- 	t1_id INTEGER,
-- 	t2_id INTEGER,
--     PRIMARY KEY (t1_id, t2_id),
--     FOREIGN KEY (t1_id) 
--     REFERENCES exampleTable1 (id) 
--     ON DELETE NO ACTION 
--     ON UPDATE NO ACTION,
--     FOREIGN KEY (t2_id) 
--     REFERENCES exampleTable2 (id) 
--     ON DELETE NO ACTION 
--     ON UPDATE NO ACTION
    
-- );
-- CREATE TABLE exampleTable3 (
-- 	id INTEGER PRIMARY KEY AUTOINCREMENT,
-- 	content TEXT NOT NULL
-- );

-- CREATE TABLE exampleTable4 (
-- 	id INTEGER PRIMARY KEY AUTOINCREMENT,
-- 	content TEXT NOT NULL,
-- 	referencingTableId INTEGER,
--     FOREIGN KEY (referencingTableId) 
--     REFERENCES exampleTable4 (id) 
--     ON DELETE CASCADE 
--     ON UPDATE NO ACTION
-- );

